import numpy as np
import elements
import graphics

print("Hi World!")

## Tests

H = (1/np.sqrt(2))*np.array([[1, 1],[1, -1]], dtype='complex')
H_rev = (1/np.sqrt(2))*np.array([[-1, 1],[1, 1]], dtype='complex')

A = np.kron(H_rev, np.eye(2, dtype='complex')) # first beam splitter matrix
B = np.kron(H, np.eye(2, dtype='complex')) # second beam splitter matrix

X = np.array([[0, 1], [1, 0]], dtype='complex')
Z = np.array([[1, 0], [0, -1]], dtype='complex')


source = elements.Source(initial_vector = np.array([1.+0j, 0.]))

BS1 = elements.BeamSplitter(previous = {"left": (source, "left"), "right": None}, matrix=A)

X_left_1 = elements.Plate(previous = (BS1, "left"), jones_matrix=X)
Z_left_2 = elements.Plate(previous = (X_left_1, "left"), jones_matrix = Z)


Z_right_1 = elements.Plate(previous = (BS1, "right"), jones_matrix = Z)
X_right_2 = elements.Plate(previous = (Z_right_1, "left"), jones_matrix = X)

BS2 = elements.BeamSplitter(previous = {"left": (Z_left_2, "left"), "right": (X_right_2, "left")}, matrix = B)

screen = elements.Screen(previous = (BS2, "left"))

print(screen.out())
